Compare commits

...

138 Commits

Author SHA1 Message Date
repo-ranger[bot]
5184a750a6 Merge pull request #649 from tj-actions/chore/update-test
chore: updated test
2022-09-25 06:12:03 +00:00
Tonye Jack
f60f9d4d6b chore: updated test 2022-09-25 00:00:23 -06:00
Tonye Jack
9d736a1803 Merge pull request #648 from tj-actions/chore/update-docs 2022-09-24 22:29:29 -06:00
Tonye Jack
d77ab55ce1 chore: update docs 2022-09-24 21:20:05 -06:00
Tonye Jack
13c0052761 Merge pull request #647 from tj-actions/chore/remove-logging-the-github-context 2022-09-24 21:03:00 -06:00
Tonye Jack
bc7fa5e550 Updated determining the remote sha 2022-09-24 20:52:05 -06:00
Tonye Jack
3d7cff9835 chore: remove logging the github context 2022-09-24 20:28:43 -06:00
Tonye Jack
cc6619bd58 Merge pull request #646 from tj-actions/chore/improve-debug-message 2022-09-24 20:27:17 -06:00
Tonye Jack
4cd2d9f19e Fixed test 2022-09-24 20:21:08 -06:00
Tonye Jack
69d9410ad3 chore: improve debug message. 2022-09-24 19:59:18 -06:00
Tonye Jack
f038bbbed9 Merge pull request #644 from tj-actions/feat/make-since-last-remote-the-default 2022-09-24 19:45:29 -06:00
Tonye Jack
05f9744e41 remove unused code 2022-09-24 19:33:47 -06:00
Tonye Jack
ef1134dca7 update to handle the default event.before 2022-09-24 19:33:05 -06:00
Tonye Jack
de772eb038 added empty line 2022-09-24 19:11:18 -06:00
Tonye Jack
5485a02af8 Updated to use the last remote commit by default. 2022-09-24 19:08:58 -06:00
Tonye Jack
2c4c729f2a revert removing since-last-remote-commit input 2022-09-24 18:59:22 -06:00
Tonye Jack
b6b72a44c8 Updated to use INPUT_HAS_CUSTOM_PATTERNS. 2022-09-24 18:35:01 -06:00
Tonye Jack
0ec94592d4 Renamed entrypoint.sh -> get-changed-paths.sh 2022-09-24 18:30:52 -06:00
Tonye Jack
068970bff8 reorder inputs 2022-09-24 18:12:07 -06:00
Tonye Jack
26361016d9 Fixed test. 2022-09-24 17:49:47 -06:00
Tonye Jack
1f907ee3bb feat: make since_last_remote the default for push events 2022-09-24 13:07:33 -06:00
Tonye Jack
fc8e4597a7 Update README.md 2022-09-24 12:36:07 -06:00
Tonye Jack
08dfcc4c04 Update README.md 2022-09-24 12:30:01 -06:00
Tonye Jack
8cbcb5bd41 Merge pull request #643 from tj-actions/chore/update-test
chore: update test
2022-09-24 09:17:49 -06:00
Tonye Jack
865fd6e79a chore: update test 2022-09-24 00:48:58 -06:00
Tonye Jack
769bb7f140 Merge pull request #642 from tj-actions/chore/update-broken-link
chore: update broken link
2022-09-24 00:34:34 -06:00
Tonye Jack
ca2731c4b9 chore: update broken link 2022-09-24 00:34:19 -06:00
Tonye Jack
2bbb2f249d Update README.md 2022-09-24 00:00:08 -06:00
Tonye Jack
bb03b8754a Merge pull request #641 from tj-actions/upgrade-to-v30.0.0
Upgraded to v30.0.0
2022-09-23 23:57:41 -06:00
jackton1
3e3de07034 Upgraded from v29 -> v30.0.0 2022-09-24 05:53:14 +00:00
Tonye Jack
402f3827f0 Update README.md 2022-09-23 23:46:13 -06:00
Tonye Jack
8e3ce84d94 Merge pull request #640 from tj-actions/feat/add-support-for-closed-pull-request-with-merge-set-to-true
feat: add support for closed pull requests with merge true
2022-09-23 23:37:38 -06:00
Tonye Jack
8e99cd3206 Update test.yml 2022-09-23 23:26:19 -06:00
Tonye Jack
9fdf62af89 Update test.yml 2022-09-23 23:16:40 -06:00
Tonye Jack
1bc25030ee Update action.yml 2022-09-23 23:12:06 -06:00
Tonye Jack
69cb60a7bb Update action.yml 2022-09-23 22:57:32 -06:00
Tonye Jack
7939ced35e feat: add support for closed pull requests with merge true
Closes: #635
2022-09-23 22:56:09 -06:00
Tonye Jack
0144a27348 Merge pull request #638 from tj-actions/chore/log-github-context
chore: log the github context in the test
2022-09-23 02:24:41 -06:00
Tonye Jack
27dd522957 chore: log the github context in the test 2022-09-23 02:24:05 -06:00
Tonye Jack
fa9e2ce8bf Merge pull request #637 from tj-actions/feat/add-support-for-running-action-on-pull-request-close-event 2022-09-21 09:49:10 -06:00
Tonye Jack
6a02815615 feat: add support for running action on pull request close event 2022-09-20 23:12:02 -06:00
renovate[bot]
fa5d3d59a3 chore(deps): update peter-evans/create-pull-request action to v4.1.2 2022-09-20 21:50:42 -06:00
renovate[bot]
723b5d3f7d chore(deps): update codacy/codacy-analysis-cli-action action to v4.2.0 2022-09-20 12:36:24 -06:00
Tonye Jack
a2e52d663f Merge pull request #633 from tj-actions/upgrade-to-v29.0.9
Upgraded to v29.0.9
2022-09-19 23:32:21 -06:00
Tonye Jack
99444e8f79 Update README.md 2022-09-19 23:32:07 -06:00
jackton1
024cd9adae Upgraded from v29.0.8 -> v29.0.9 2022-09-20 05:09:44 +00:00
Tonye Jack
f7a56405a8 Updated .github/workflows/sync-release-version.yml 2022-09-19 22:57:53 -06:00
Tonye Jack
a6b6d5ba9a Merge pull request #632 from tj-actions/upgrade-to-v29.0.8
Upgraded to v29.0.8
2022-09-19 22:42:26 -06:00
jackton1
ab92e76dc8 Upgraded from v29.0.8 -> v29.0.8 2022-09-20 04:09:43 +00:00
Tonye Jack
c87fbfdc3b Updated .github/workflows/sync-release-version.yml 2022-09-19 22:09:27 -06:00
Tonye Jack
8356556044 Updated .github/workflows/codacy-analysis.yml 2022-09-19 21:00:57 -06:00
Tonye Jack
0bdc1cda4e Updated .github/workflows/codacy-analysis.yml 2022-09-19 20:34:41 -06:00
Tonye Jack
fa269949dd Updated .github/workflows/greetings.yml 2022-09-19 20:34:13 -06:00
Tonye Jack
1060db9be7 Updated .github/workflows/codacy-analysis.yml 2022-09-19 20:31:08 -06:00
Tonye Jack
df4dacaa89 Updated .github/ISSUE_TEMPLATE/bug_report.yaml 2022-09-19 20:25:10 -06:00
Tonye Jack
ee96eba261 Updated .github/ISSUE_TEMPLATE/feature_request.yaml 2022-09-19 20:24:40 -06:00
Tonye Jack
172663c1a0 Updated .github/ISSUE_TEMPLATE/bug_report.yaml 2022-09-19 20:07:58 -06:00
Tonye Jack
f2e68be9bb Updated .github/workflows/sync-release-version.yml 2022-09-19 20:06:31 -06:00
renovate[bot]
242ef530a8 chore(deps): update tj-actions/sync-release-version action to v13 2022-09-19 18:58:06 -06:00
Tonye Jack
22a9e7512b Merge pull request #630 from tj-actions/629-feature-improve-docs-related-to-files 2022-09-19 18:14:22 -06:00
Tonye Jack
41562df308 Update README.md 2022-09-19 18:11:49 -06:00
Tonye Jack
4e7053cfd8 Update README.md 2022-09-19 07:41:36 -06:00
Tonye Jack
42f7377ae0 Update README.md 2022-09-19 07:39:09 -06:00
Tonye Jack
086ffa020e Merge pull request #628 from tj-actions/upgrade-to-v29.0.7 2022-09-13 11:39:23 -06:00
jackton1
38731065db Upgraded from v29.0.6 -> v29.0.7 2022-09-13 17:23:34 +00:00
Tonye Jack
602081b5d9 Merge pull request #626 from tj-actions/upgrade-to-v29.0.6 2022-09-13 10:22:01 -06:00
Tonye Jack
15c8c40ba8 Merge branch 'main' into upgrade-to-v29.0.6 2022-09-13 09:55:03 -06:00
Tonye Jack
b0bd577697 Merge pull request #627 from tj-actions/fix/bug-with-setting-the-last-remote-commit 2022-09-13 09:54:38 -06:00
Tonye Jack
86eef8cdff fix: bug with setting the LAST_REMOTE_COMMIT 2022-09-13 09:54:25 -06:00
jackton1
437049ca22 Upgraded from v29.0.5 -> v29.0.6 2022-09-13 15:13:54 +00:00
Tonye Jack
6e12407521 Merge pull request #625 from tj-actions/upgrade-to-v29.0.5 2022-09-13 08:27:51 -06:00
Tonye Jack
8fcb602161 Update action.yml 2022-09-13 08:12:44 -06:00
jackton1
51af91599b Upgraded from v29.0.4 -> v29.0.5 2022-09-13 05:36:32 +00:00
Tonye Jack
c5c9b6ff9e Merge pull request #624 from tj-actions/fix/bug-since_last_remote_commit-does-not-work-in-v2904
fix: bug with last remote commit sha
2022-09-12 22:34:47 -06:00
Tonye Jack
e3b5eb746a fix: bug with last remote commit sha 2022-09-12 22:04:33 -06:00
Tonye Jack
cc8c5e7787 Update README.md 2022-09-12 14:50:56 -06:00
Tonye Jack
4717fbffaa Update README.md 2022-09-12 14:50:21 -06:00
Tonye Jack
d552acdbfc Merge pull request #622 from tj-actions/chore/update-readme 2022-09-12 14:49:37 -06:00
Tonye Jack
c28e2996d2 Update README.md 2022-09-12 14:49:21 -06:00
Tonye Jack
ad33a235d2 Update README.md 2022-09-12 14:47:54 -06:00
renovate[bot]
ba0dd99ea1 chore(deps): update tj-actions/github-changelog-generator action to v1.15 2022-09-09 20:44:22 -06:00
Tonye Jack
840016d287 Merge pull request #620 from tj-actions/feat/warn-when-since/until-inputs-are-set-but-not-corresponding-sha-is-found 2022-09-08 13:24:52 -06:00
Tonye Jack
0c9b5d5c37 feat: warn when since/until inputs are set but not corresponding sha is found 2022-09-08 12:33:11 -06:00
Tonye Jack
4f7185fe00 Merge pull request #619 from tj-actions/chore/update-readme 2022-09-08 10:55:41 -06:00
Tonye Jack
095002c917 chore: update readme 2022-09-08 10:55:31 -06:00
Tonye Jack
83322c2e9c Merge pull request #618 from tj-actions/upgrade-to-v29.0.4
Upgraded to v29.0.4
2022-09-07 21:33:23 -06:00
jackton1
03ef174aec Upgraded from v29.0.3 -> v29.0.4 2022-09-08 02:56:54 +00:00
Tonye Jack
c41b715259 Merge pull request #617 from tj-actions/fix/bug-with-similar-commits-when-github-event-before-is-empty 2022-09-07 19:55:13 -06:00
Tonye Jack
d0e5182f78 fix: bug with similar commits when github.event.before is empty
Closes: #615
2022-09-07 18:07:19 -06:00
Tonye Jack
17ea45322d Merge pull request #616 from tj-actions/chore/set-defaults-for-until-and-since-inputs 2022-09-07 13:51:36 -06:00
Tonye Jack
7b0c3d7790 chore: set defaults for until and since inputs 2022-09-07 09:43:10 -06:00
Tonye Jack
9461e99923 Merge pull request #613 from tj-actions/chore/update-readme
chore: update readme
2022-09-05 10:49:39 -06:00
Tonye Jack
b4c0efad44 chore: update readme 2022-09-05 10:43:20 -06:00
Tonye Jack
98d07d49b8 Merge pull request #611 from tj-actions/chore/test-using-for-loop-with-output
chore: test using for loop with output
2022-09-04 23:36:24 -06:00
Tonye Jack
bbc26e5efa Update test.yml 2022-09-04 23:34:23 -06:00
Tonye Jack
01d9c79ad2 Update test.yml 2022-09-04 23:20:36 -06:00
Tonye Jack
48326e19ea Update test rename 1.txt 2022-09-04 22:29:48 -06:00
Tonye Jack
bf534010c8 Update test rename 2.txt 2022-09-04 22:29:27 -06:00
Tonye Jack
be849d1612 chore: test using for loop with output 2022-09-04 22:28:32 -06:00
Tonye Jack
3da07e5b14 Merge pull request #610 from tj-actions/docs/update-reference-to-setting-env-variables
docs: update reference to setting input env variables
2022-09-04 17:22:42 -06:00
Tonye Jack
4ad3c84be0 docs: update reference to setting input env variables 2022-09-04 17:21:34 -06:00
Tonye Jack
5cd280e718 Merge pull request #607 from tj-actions/upgrade-to-v29.0.3
Upgraded to v29.0.3
2022-09-03 07:05:15 -06:00
jackton1
9a417daee7 Upgraded from v29.0.2 -> v29.0.3 2022-09-03 02:44:20 +00:00
Tonye Jack
60f4aabced Merge pull request #606 from tj-actions/fix/bug-using-invalid-fetch-depth
fix: bug using invalid fetch-depth
2022-09-02 20:39:54 -06:00
Tonye Jack
5dd27b18ae update test name 2022-09-02 18:55:27 -06:00
Tonye Jack
6ffc0e26e3 added continue-on-error. 2022-09-02 18:50:38 -06:00
Tonye Jack
dcd088713a updated debug message. 2022-09-02 18:40:51 -06:00
Tonye Jack
3a8cb18589 update the test. 2022-09-02 18:32:08 -06:00
Tonye Jack
16e8ea38da Updated the test 2022-09-02 18:25:29 -06:00
Tonye Jack
618e703768 Fixed bug with setting the exit status 2022-09-02 18:23:52 -06:00
Tonye Jack
1faa996b87 Updated setting the exit status 2022-09-02 16:41:25 -06:00
Tonye Jack
0f7f451225 updated tested platforms. 2022-09-02 15:24:30 -06:00
Tonye Jack
4472745cf1 add debug message. 2022-09-02 15:20:06 -06:00
Tonye Jack
52a83d3ef3 fix: bug using invalid fetch-depth 2022-09-02 15:08:19 -06:00
Tonye Jack
cb433740f0 chore: test invalid fetch-depth 2022-09-01 13:14:33 -06:00
Tonye Jack
3f5b196783 Update README.md 2022-08-29 09:08:43 -06:00
Tonye Jack
c6b48fe911 Merge pull request #604 from tj-actions/upgrade-to-v29.0.2 2022-08-29 01:29:21 -06:00
jackton1
e0bd90b74a Upgraded from v29.0.1 -> v29.0.2 2022-08-29 04:22:48 +00:00
Tonye Jack
82edb42dc4 Merge pull request #603 from tj-actions/chore/remove-unused-input
chore: remove unused input
2022-08-28 22:13:57 -06:00
Tonye Jack
cbcaf86272 Update README.md 2022-08-28 13:58:08 -06:00
Tonye Jack
30ac0d5e30 chore: remove unused input 2022-08-28 13:54:28 -06:00
renovate[bot]
62f3ac4728 chore(deps): update tj-actions/branch-names action to v6 2022-08-27 10:56:02 -06:00
Tonye Jack
3491f60cd2 Update README.md 2022-08-26 17:02:42 -06:00
Tonye Jack
da64026a59 Merge pull request #601 from tj-actions/upgrade-to-v29.0.1 2022-08-25 23:49:04 -06:00
jackton1
06f041ee63 Upgraded from v29.0.0 -> v29.0.1 2022-08-26 05:47:06 +00:00
Tonye Jack
18edda7475 Merge pull request #600 from tj-actions/fix/bug-with-dir-names 2022-08-25 23:45:04 -06:00
Tonye Jack
0268ea521b Update entrypoint.sh 2022-08-25 23:34:13 -06:00
Tonye Jack
841d7d379c Update entrypoint.sh 2022-08-25 23:31:47 -06:00
Tonye Jack
b12ac5bdd5 Update action.yml 2022-08-25 23:25:39 -06:00
Tonye Jack
967b5466c0 Update entrypoint.sh 2022-08-25 23:25:09 -06:00
Tonye Jack
559d530325 debug the path output file 2022-08-25 22:14:40 -06:00
Tonye Jack
b1929916fa fixed bug with pattern matching. 2022-08-25 22:12:38 -06:00
Tonye Jack
646144ddf8 fixed bug with pattern matching. 2022-08-25 22:09:42 -06:00
Tonye Jack
1bf658c5ba debug the path output file 2022-08-25 21:53:36 -06:00
Tonye Jack
659d5814cd Merge branch 'main' into fix/bug-with-dir-names 2022-08-25 21:49:01 -06:00
Tonye Jack
6aa0ae3b2c fix: bug with dir name 2022-08-25 21:46:41 -06:00
Tonye Jack
a9c3a8135d Merge pull request #597 from tj-actions/upgrade-to-v29.0.0
Upgraded to v29.0.0
2022-08-23 08:57:34 -06:00
jackton1
baedfec11a Upgraded from v28.0.0 -> v29.0.0 2022-08-23 14:45:00 +00:00
18 changed files with 463 additions and 208 deletions

View File

@@ -69,8 +69,8 @@ body:
id: logs
attributes:
label: Relevant log output
description: Please copy and paste any relevant log outputs after enabling debug logging using ACTIONS_STEP_DEBUG=true See https://docs.github.com/en/actions/monitoring-and-troubleshooting-workflows/enabling-debug-logging. This will be automatically formatted into code, so no need for backticks.
render: bash
description: Please copy and paste any relevant log output. This will be automatically formatted into code, so no need for backticks.
render: shell
- type: textarea
attributes:
label: Anything else?

View File

@@ -53,7 +53,7 @@ body:
id: terms
attributes:
label: Code of Conduct
description: By submitting this issue, you agree to follow our [Code of Conduct](./CODE_OF_CONDUCT.md)
description: By submitting this issue, you agree to follow our [Code of Conduct](../blob/main/CODE_OF_CONDUCT.md)
options:
- label: I agree to follow this project's Code of Conduct
required: true

View File

@@ -19,6 +19,11 @@ on:
jobs:
codacy-security-scan:
# Cancel other workflows that are running for the same branch
# https://docs.github.com/en/actions/reference/workflow-syntax-for-github-actions#concurrency
concurrency:
group: ${{ github.workflow }}-${{ github.ref }}
cancel-in-progress: true
name: Codacy Security Scan
runs-on: ubuntu-latest
steps:
@@ -28,7 +33,8 @@ jobs:
# Execute Codacy Analysis CLI and generate a SARIF output with the security issues identified during the analysis
- name: Run Codacy Analysis CLI
uses: codacy/codacy-analysis-cli-action@v4.1.0
continue-on-error: true
uses: codacy/codacy-analysis-cli-action@v4.2.0
with:
# Check https://github.com/codacy/codacy-analysis-cli#project-token to get your project token from your Codacy repository
# You can also omit the token and run the tools that support default configurations
@@ -39,11 +45,12 @@ jobs:
# Adjust severity of non-security issues
gh-code-scanning-compat: true
# Force 0 exit code to allow SARIF file generation
# This will handover control about PR rejection to the GitHub side
# This will hand over control about PR rejection to the GitHub side
max-allowed-issues: 2147483647
# Upload the SARIF file generated in the previous step
- name: Upload SARIF results file
continue-on-error: true
uses: github/codeql-action/upload-sarif@v2
with:
sarif_file: results.sarif

View File

@@ -9,5 +9,5 @@ jobs:
- uses: actions/first-interaction@v1.1.0
with:
repo-token: ${{ secrets.GITHUB_TOKEN }}
issue-message: "Thanks for reporting this issue, don't forget to star this project to help us reach a wider audience."
pr-message: "Thanks for implementing a fix, could you ensure that the test covers your changes."
issue-message: "Thanks for reporting this issue, don't forget to star this project if you haven't already to help us reach a wider audience."
pr-message: "Thanks for implementing a fix, could you ensure that the test covers your changes if applicable."

View File

@@ -11,7 +11,7 @@ jobs:
fail-fast: false
max-parallel: 4
matrix:
platform: [ubuntu-latest, windows-latest, macos-latest, macos-11, ubuntu-18.04, windows-2022]
platform: [ubuntu-latest, ubuntu-22.04, windows-latest, macos-latest, macos-11, ubuntu-18.04, windows-2022]
steps:
- name: Checkout

View File

@@ -19,7 +19,7 @@ jobs:
git submodule update --remote --recursive
- name: Create Pull Request
uses: peter-evans/create-pull-request@v4.1.1
uses: peter-evans/create-pull-request@v4.1.2
with:
title: "Updated submodule"
branch: "chore/update-submodule"

View File

@@ -8,22 +8,25 @@ jobs:
update-version:
runs-on: ubuntu-latest
steps:
- uses: actions/checkout@v3.0.2
- uses: actions/checkout@v3
with:
fetch-depth: 0
- name: Run release-tagger
uses: tj-actions/release-tagger@v2
- name: Sync release version.
uses: tj-actions/sync-release-version@v11
uses: tj-actions/sync-release-version@v13
id: sync-release-version
with:
pattern: '${{ github.repository }}@'
only_major: true
paths: |
README.md
- name: Generate CHANGELOG
uses: tj-actions/github-changelog-generator@v1.14
uses: tj-actions/github-changelog-generator@v1.15
with:
output: 'HISTORY.md'
- name: Create Pull Request
uses: peter-evans/create-pull-request@v4.1.1
uses: peter-evans/create-pull-request@v4.1.2
with:
base: "main"
title: "Upgraded to ${{ steps.sync-release-version.outputs.new_version }}"

View File

@@ -6,6 +6,11 @@ on:
- main
- "**"
pull_request:
types:
- closed
- opened
- synchronize
- reopened
branches:
- main
pull_request_review:
@@ -23,46 +28,6 @@ jobs:
- name: shellcheck
uses: reviewdog/action-shellcheck@v1.15
test-pull-requests-from-forks:
name: Test changed-files diff on pull_requests from forks
runs-on: ${{ matrix.platform }}
strategy:
fail-fast: false
max-parallel: 4
matrix:
platform: [ubuntu-latest, windows-latest, macos-latest, macos-11, ubuntu-18.04, windows-2022]
steps:
- name: Checkout
uses: actions/checkout@v3
with:
submodules: true
fetch-depth: 0
- name: Get changed files use_fork_point
id: changed-files-fork-point
uses: ./
with:
use_fork_point: "true"
- name: Show output
run: |
echo '${{ toJSON(steps.changed-files-fork-point.outputs) }}'
shell:
bash
- name: Get changed files
id: changed-files
uses: ./
with:
base_sha: ${{ github.event.pull_request.base.sha }}
- name: Show output
run: |
echo '${{ toJSON(steps.changed-files.outputs) }}'
shell:
bash
test-multiple-repositories:
name: Test with multiple repositories
runs-on: ${{ matrix.platform }}
@@ -70,7 +35,7 @@ jobs:
fail-fast: false
max-parallel: 4
matrix:
platform: [ubuntu-latest, windows-latest, macos-latest, macos-11, ubuntu-18.04, windows-2022]
platform: [ubuntu-latest, ubuntu-22.04, windows-latest, macos-latest, macos-11, ubuntu-18.04, windows-2022]
steps:
- name: Checkout into dir1
uses: actions/checkout@v3
@@ -126,15 +91,59 @@ jobs:
fail-fast: false
max-parallel: 4
matrix:
platform: [ubuntu-latest, windows-latest, macos-latest, macos-11, ubuntu-18.04, windows-2022]
platform: [ubuntu-latest, ubuntu-22.04, windows-latest, macos-latest, macos-11, ubuntu-18.04, windows-2022]
steps:
- name: Checkout to branch
uses: actions/checkout@v3
with:
fetch-depth: 0
- name: Run changed-files with similar base and commit sha
id: changed-files
continue-on-error: true
uses: ./
with:
base_sha: d1c0ee4
sha: d1c0ee4
- name: Exit with 1 if no error is raised
if: steps.changed-files.outcome != 'failure'
run: |
echo "Expected: (failure) got ${{ steps.changed-files.outcome }}"
exit 1
- name: Show output
run: |
echo '${{ toJSON(steps.changed-files.outputs) }}'
shell:
bash
test-single-commit-history:
name: Test changed-files single commit history
runs-on: ${{ matrix.platform }}
strategy:
fail-fast: false
max-parallel: 4
matrix:
platform: [ubuntu-latest, ubuntu-22.04, windows-latest, macos-latest, macos-11, ubuntu-18.04, windows-2022]
steps:
- name: Checkout to branch
uses: actions/checkout@v3
with:
fetch-depth: 1
- name: Run changed-files with a single commit history
id: changed-files
continue-on-error: true
uses: ./
- name: Exit with 1 if no error is raised
if: github.event_name == 'pull_request' && steps.changed-files.outcome != 'failure'
run: |
echo "Expected: (failure) got ${{ steps.changed-files.outcome }}"
exit 1
- name: Show output
run: |
@@ -149,7 +158,7 @@ jobs:
fail-fast: false
max-parallel: 4
matrix:
platform: [ubuntu-latest, windows-latest, macos-latest, macos-11, ubuntu-18.04, windows-2022]
platform: [ubuntu-latest, ubuntu-22.04, windows-latest, macos-latest, macos-11, ubuntu-18.04, windows-2022]
steps:
- name: Checkout to branch
@@ -201,7 +210,7 @@ jobs:
fail-fast: false
max-parallel: 4
matrix:
platform: [ubuntu-latest, windows-latest, macos-latest, macos-11, ubuntu-18.04, windows-2022]
platform: [ubuntu-latest, ubuntu-22.04, windows-latest, macos-latest, macos-11, ubuntu-18.04, windows-2022]
steps:
- name: Checkout to branch
@@ -253,7 +262,7 @@ jobs:
fail-fast: false
max-parallel: 4
matrix:
platform: [ubuntu-latest, windows-latest, macos-latest, macos-11, ubuntu-18.04, windows-2022]
platform: [ubuntu-latest, ubuntu-22.04, windows-latest, macos-latest, macos-11, ubuntu-18.04, windows-2022]
steps:
- name: Checkout
@@ -296,12 +305,21 @@ jobs:
id: changed-files-dir-names
uses: ./
with:
base_sha: d1c0ee4
sha: 4d04215
dir_names: "true"
- name: Show output
run: |
echo '${{ toJSON(steps.changed-files-dir-names.outputs) }}'
shell:
bash
- name: Check dir_names output
if: "!contains(steps.changed-files-dir-names.outputs.all_changed_files, 'test')"
run: |
echo "Invalid output: Expected to include (test) got (${{ steps.changed-files-dir-names.outputs.all_changed_files }})"
exit 1
shell:
bash
- name: Run changed-files since 2022-08-19
id: changed-files-since
uses: ./
@@ -370,6 +388,15 @@ jobs:
uses: ./
with:
separator: ","
- name: List all modified files
run: |
IFS=$',' read -a MODIFIED_FILES_ARRAY <<< "${{ steps.changed-files-comma.outputs.modified_files }}"
for file in "${MODIFIED_FILES_ARRAY[@]}"; do
echo $file
done
unset IFS
shell:
bash
- name: Show output
run: |
echo '${{ toJSON(steps.changed-files-comma.outputs) }}'
@@ -493,10 +520,10 @@ jobs:
uses: ./
with:
files: |
entrypoint.sh
get-changed-paths.sh
*.sh
- name: Verify all_changed_files files has no duplicates
if: contains(steps.changed-files-specific-duplicate-output.outputs.all_changed_files, 'entrypoint.sh')
if: contains(steps.changed-files-specific-duplicate-output.outputs.all_changed_files, 'get-changed-paths.sh')
run: |
ALL_CHANGED_FILES=(${{ steps.changed-files-specific-duplicate-output.outputs.all_changed_files }})
UNIQUE_ALL_CHANGED_FILES=$(echo "$ALL_CHANGED_FILES" | tr ' ' '\n' | sort -u | xargs)
@@ -508,7 +535,7 @@ jobs:
shell:
bash
- name: Verify all_changed_and_modified_files files has no duplicates
if: contains(steps.changed-files-specific-duplicate-output.outputs.all_changed_and_modified_files, 'entrypoint.sh')
if: contains(steps.changed-files-specific-duplicate-output.outputs.all_changed_and_modified_files, 'get-changed-paths.sh')
run: |
ALL_CHANGED_AND_MODIFIED_FILES=(${{ steps.changed-files-specific-duplicate-output.outputs.all_changed_and_modified_files }})
UNIQUE_ALL_CHANGED_AND_MODIFIED_FILES=$(echo "$ALL_CHANGED_AND_MODIFIED_FILES" | tr ' ' '\n' | sort -u | xargs)
@@ -520,7 +547,7 @@ jobs:
shell:
bash
- name: Verify all_modified_files files has no duplicates
if: contains(steps.changed-files-specific-duplicate-output.outputs.all_modified_files, 'entrypoint.sh')
if: contains(steps.changed-files-specific-duplicate-output.outputs.all_modified_files, 'get-changed-paths.sh')
run: |
ALL_MODIFIED_FILES=(${{ steps.changed-files-specific-duplicate-output.outputs.all_modified_files }})
UNIQUE_ALL_MODIFIED_FILES=$(echo "$ALL_MODIFIED_FILES" | tr ' ' '\n' | sort -u | xargs)
@@ -786,23 +813,23 @@ jobs:
bash
- name: Get branch name
id: branch-name
uses: tj-actions/branch-names@v5
uses: tj-actions/branch-names@v6
if: github.event_name == 'pull_request'
- uses: nrwl/last-successful-commit-action@v1
id: last_successful_commit
if: github.event_name == 'pull_request'
if: github.event_name == 'pull_request' && github.event.action != 'closed'
with:
branch: ${{ steps.branch-name.outputs.base_ref_branch }}
workflow_id: 'test.yml'
github_token: ${{ secrets.GITHUB_TOKEN }}
- name: Run changed-files with a custom base sha
if: github.event_name == 'pull_request'
if: github.event_name == 'pull_request' && github.event.action != 'closed'
id: changed-files-custom-base-sha
uses: ./
with:
base_sha: ${{ steps.last_successful_commit.outputs.commit_hash }}
- name: Show output
if: github.event_name == 'pull_request'
if: github.event_name == 'pull_request' && github.event.action != 'closed'
run: |
echo '${{ toJSON(steps.changed-files-custom-base-sha.outputs) }}'
shell:

View File

@@ -31,7 +31,7 @@ jobs:
- name: Create Pull Request
if: failure()
uses: peter-evans/create-pull-request@v4.1.1
uses: peter-evans/create-pull-request@v4.1.2
with:
base: "main"
title: "Updated README.md"

View File

@@ -1,5 +1,168 @@
# Changelog
## [v30.0.0](https://github.com/tj-actions/changed-files/tree/v30.0.0) (2022-09-24)
[Full Changelog](https://github.com/tj-actions/changed-files/compare/v30...v30.0.0)
## [v30](https://github.com/tj-actions/changed-files/tree/v30) (2022-09-24)
[Full Changelog](https://github.com/tj-actions/changed-files/compare/v29.0.9...v30)
**Fixed bugs:**
- \[BUG\] Can't get all changed files after pushing new commit [\#639](https://github.com/tj-actions/changed-files/issues/639)
- \[BUG\] Add support for pull request close event with merge set to true [\#635](https://github.com/tj-actions/changed-files/issues/635)
**Closed issues:**
- Dependency Dashboard [\#27](https://github.com/tj-actions/changed-files/issues/27)
**Merged pull requests:**
- feat: add support for closed pull requests with merge true [\#640](https://github.com/tj-actions/changed-files/pull/640) ([jackton1](https://github.com/jackton1))
- chore: log the github context in the test [\#638](https://github.com/tj-actions/changed-files/pull/638) ([jackton1](https://github.com/jackton1))
- feat: add support for running action on pull request close event [\#637](https://github.com/tj-actions/changed-files/pull/637) ([jackton1](https://github.com/jackton1))
- chore\(deps\): update peter-evans/create-pull-request action to v4.1.2 [\#636](https://github.com/tj-actions/changed-files/pull/636) ([renovate[bot]](https://github.com/apps/renovate))
- chore\(deps\): update codacy/codacy-analysis-cli-action action to v4.2.0 [\#634](https://github.com/tj-actions/changed-files/pull/634) ([renovate[bot]](https://github.com/apps/renovate))
- Upgraded to v29.0.9 [\#633](https://github.com/tj-actions/changed-files/pull/633) ([jackton1](https://github.com/jackton1))
## [v29.0.9](https://github.com/tj-actions/changed-files/tree/v29.0.9) (2022-09-20)
[Full Changelog](https://github.com/tj-actions/changed-files/compare/v29...v29.0.9)
## [v29](https://github.com/tj-actions/changed-files/tree/v29) (2022-09-20)
[Full Changelog](https://github.com/tj-actions/changed-files/compare/v29.0.8...v29)
**Implemented enhancements:**
- \[Feature\] Publish `v29` release that redirects to the latest version within the major version [\#612](https://github.com/tj-actions/changed-files/issues/612)
**Merged pull requests:**
- Upgraded to v29.0.8 [\#632](https://github.com/tj-actions/changed-files/pull/632) ([jackton1](https://github.com/jackton1))
## [v29.0.8](https://github.com/tj-actions/changed-files/tree/v29.0.8) (2022-09-20)
[Full Changelog](https://github.com/tj-actions/changed-files/compare/v29.0.7...v29.0.8)
**Implemented enhancements:**
- \[Feature\] Improve docs related to "files" [\#629](https://github.com/tj-actions/changed-files/issues/629)
**Merged pull requests:**
- chore\(deps\): update tj-actions/sync-release-version action to v13 [\#631](https://github.com/tj-actions/changed-files/pull/631) ([renovate[bot]](https://github.com/apps/renovate))
- chore: update docs to include notice about using quotes in multiline patterns [\#630](https://github.com/tj-actions/changed-files/pull/630) ([jackton1](https://github.com/jackton1))
- Upgraded to v29.0.7 [\#628](https://github.com/tj-actions/changed-files/pull/628) ([jackton1](https://github.com/jackton1))
## [v29.0.7](https://github.com/tj-actions/changed-files/tree/v29.0.7) (2022-09-13)
[Full Changelog](https://github.com/tj-actions/changed-files/compare/v29.0.6...v29.0.7)
**Merged pull requests:**
- fix: bug with setting the LAST\_REMOTE\_COMMIT [\#627](https://github.com/tj-actions/changed-files/pull/627) ([jackton1](https://github.com/jackton1))
- Upgraded to v29.0.6 [\#626](https://github.com/tj-actions/changed-files/pull/626) ([jackton1](https://github.com/jackton1))
## [v29.0.6](https://github.com/tj-actions/changed-files/tree/v29.0.6) (2022-09-13)
[Full Changelog](https://github.com/tj-actions/changed-files/compare/v29.0.5...v29.0.6)
**Fixed bugs:**
- \[BUG\] since\_last\_remote\_commit does not work in v29.0.4 [\#623](https://github.com/tj-actions/changed-files/issues/623)
**Merged pull requests:**
- Upgraded to v29.0.5 [\#625](https://github.com/tj-actions/changed-files/pull/625) ([jackton1](https://github.com/jackton1))
## [v29.0.5](https://github.com/tj-actions/changed-files/tree/v29.0.5) (2022-09-13)
[Full Changelog](https://github.com/tj-actions/changed-files/compare/v29.0.4...v29.0.5)
**Fixed bugs:**
- \[BUG\] Unable to fetch file changes on merge event [\#615](https://github.com/tj-actions/changed-files/issues/615)
**Merged pull requests:**
- fix: bug with last remote commit sha [\#624](https://github.com/tj-actions/changed-files/pull/624) ([jackton1](https://github.com/jackton1))
- chore: update README.md [\#622](https://github.com/tj-actions/changed-files/pull/622) ([jackton1](https://github.com/jackton1))
- chore\(deps\): update tj-actions/github-changelog-generator action to v1.15 [\#621](https://github.com/tj-actions/changed-files/pull/621) ([renovate[bot]](https://github.com/apps/renovate))
- feat: warn when since/until inputs are set but not corresponding sha is found [\#620](https://github.com/tj-actions/changed-files/pull/620) ([jackton1](https://github.com/jackton1))
- chore: update readme [\#619](https://github.com/tj-actions/changed-files/pull/619) ([jackton1](https://github.com/jackton1))
- Upgraded to v29.0.4 [\#618](https://github.com/tj-actions/changed-files/pull/618) ([jackton1](https://github.com/jackton1))
## [v29.0.4](https://github.com/tj-actions/changed-files/tree/v29.0.4) (2022-09-08)
[Full Changelog](https://github.com/tj-actions/changed-files/compare/v29.0.3...v29.0.4)
**Fixed bugs:**
- \[BUG\] Changed files are always missed on macOS [\#614](https://github.com/tj-actions/changed-files/issues/614)
**Closed issues:**
- Looping over files with spaces. [\#609](https://github.com/tj-actions/changed-files/issues/609)
- stale github.community reference [\#608](https://github.com/tj-actions/changed-files/issues/608)
**Merged pull requests:**
- fix: bug with similar commits when github.event.before is empty [\#617](https://github.com/tj-actions/changed-files/pull/617) ([jackton1](https://github.com/jackton1))
- chore: set defaults for until and since inputs [\#616](https://github.com/tj-actions/changed-files/pull/616) ([jackton1](https://github.com/jackton1))
- chore: update readme [\#613](https://github.com/tj-actions/changed-files/pull/613) ([jackton1](https://github.com/jackton1))
- chore: test using for loop with output [\#611](https://github.com/tj-actions/changed-files/pull/611) ([jackton1](https://github.com/jackton1))
- docs: update reference to setting input env variables [\#610](https://github.com/tj-actions/changed-files/pull/610) ([jackton1](https://github.com/jackton1))
- Upgraded to v29.0.3 [\#607](https://github.com/tj-actions/changed-files/pull/607) ([jackton1](https://github.com/jackton1))
## [v29.0.3](https://github.com/tj-actions/changed-files/tree/v29.0.3) (2022-09-03)
[Full Changelog](https://github.com/tj-actions/changed-files/compare/v29.0.2...v29.0.3)
**Merged pull requests:**
- fix: bug using invalid fetch-depth [\#606](https://github.com/tj-actions/changed-files/pull/606) ([jackton1](https://github.com/jackton1))
- Upgraded to v29.0.2 [\#604](https://github.com/tj-actions/changed-files/pull/604) ([jackton1](https://github.com/jackton1))
## [v29.0.2](https://github.com/tj-actions/changed-files/tree/v29.0.2) (2022-08-29)
[Full Changelog](https://github.com/tj-actions/changed-files/compare/v29.0.1...v29.0.2)
**Implemented enhancements:**
- \[Feature\] Get all changes on current branch against a base\_sha [\#599](https://github.com/tj-actions/changed-files/issues/599)
**Fixed bugs:**
- \[BUG\] dir\_names = true not returning directories with changed files [\#598](https://github.com/tj-actions/changed-files/issues/598)
**Merged pull requests:**
- chore: remove unused input [\#603](https://github.com/tj-actions/changed-files/pull/603) ([jackton1](https://github.com/jackton1))
- chore\(deps\): update tj-actions/branch-names action to v6 [\#602](https://github.com/tj-actions/changed-files/pull/602) ([renovate[bot]](https://github.com/apps/renovate))
- Upgraded to v29.0.1 [\#601](https://github.com/tj-actions/changed-files/pull/601) ([jackton1](https://github.com/jackton1))
## [v29.0.1](https://github.com/tj-actions/changed-files/tree/v29.0.1) (2022-08-26)
[Full Changelog](https://github.com/tj-actions/changed-files/compare/v29.0.0...v29.0.1)
**Merged pull requests:**
- fix: bug with dir name [\#600](https://github.com/tj-actions/changed-files/pull/600) ([jackton1](https://github.com/jackton1))
- Upgraded to v29.0.0 [\#597](https://github.com/tj-actions/changed-files/pull/597) ([jackton1](https://github.com/jackton1))
## [v29.0.0](https://github.com/tj-actions/changed-files/tree/v29.0.0) (2022-08-23)
[Full Changelog](https://github.com/tj-actions/changed-files/compare/v28.0.0...v29.0.0)
**Merged pull requests:**
- chore\(deps\): update tj-actions/glob to v12 [\#596](https://github.com/tj-actions/changed-files/pull/596) ([jackton1](https://github.com/jackton1))
- chore\(deps\): update tj-actions/verify-changed-files action to v11 [\#595](https://github.com/tj-actions/changed-files/pull/595) ([renovate[bot]](https://github.com/apps/renovate))
- chore\(deps\): Update tj-actions/glob to v11.1 [\#594](https://github.com/tj-actions/changed-files/pull/594) ([jackton1](https://github.com/jackton1))
- Upgraded to v28.0.0 [\#592](https://github.com/tj-actions/changed-files/pull/592) ([jackton1](https://github.com/jackton1))
## [v28.0.0](https://github.com/tj-actions/changed-files/tree/v28.0.0) (2022-08-21)
[Full Changelog](https://github.com/tj-actions/changed-files/compare/v28...v28.0.0)
@@ -22,10 +185,6 @@
- \[BUG\] changes based on last remote commit fail after rebasing [\#546](https://github.com/tj-actions/changed-files/issues/546)
**Closed issues:**
- Dependency Dashboard [\#27](https://github.com/tj-actions/changed-files/issues/27)
**Merged pull requests:**
- feat: add support for using time based filtering. [\#588](https://github.com/tj-actions/changed-files/pull/588) ([jackton1](https://github.com/jackton1))
@@ -907,7 +1066,7 @@
## [v1.2.1](https://github.com/tj-actions/changed-files/tree/v1.2.1) (2021-11-08)
[Full Changelog](https://github.com/tj-actions/changed-files/compare/v11.5...v1.2.1)
[Full Changelog](https://github.com/tj-actions/changed-files/compare/v1.2.0...v1.2.1)
**Implemented enhancements:**
@@ -921,13 +1080,13 @@
- Update actions/checkout action to v2.4.0 [\#243](https://github.com/tj-actions/changed-files/pull/243) ([renovate[bot]](https://github.com/apps/renovate))
- Upgraded to v11.5 [\#241](https://github.com/tj-actions/changed-files/pull/241) ([jackton1](https://github.com/jackton1))
## [v11.5](https://github.com/tj-actions/changed-files/tree/v11.5) (2021-10-30)
[Full Changelog](https://github.com/tj-actions/changed-files/compare/v1.2.0...v11.5)
## [v1.2.0](https://github.com/tj-actions/changed-files/tree/v1.2.0) (2021-10-30)
[Full Changelog](https://github.com/tj-actions/changed-files/compare/v11.4...v1.2.0)
[Full Changelog](https://github.com/tj-actions/changed-files/compare/v11.5...v1.2.0)
## [v11.5](https://github.com/tj-actions/changed-files/tree/v11.5) (2021-10-30)
[Full Changelog](https://github.com/tj-actions/changed-files/compare/v11.4...v11.5)
**Merged pull requests:**

117
README.md
View File

@@ -13,13 +13,12 @@
## changed-files
Retrieve all changed files and directories relative to the target branch (`pull_request*` based events) or the last remote commit (`push` based event) returning the **absolute path** to all changed files and directories from the project root.
Retrieve all changed files and directories relative to the target branch (`pull_request*` based events) or the last remote commit (`push` or `pull_request*` based event) returning the **absolute path** to all changed files and directories from the project root.
## Features
* Fast execution (0-2 seconds on average).
* Easy to debug.
* Boolean output indicating that certain files have been changed.
* Scales to large repositories.
* Git submodules support.
* No extra API calls.
@@ -32,11 +31,10 @@ Retrieve all changed files and directories relative to the target branch (`pull_
* [self-hosted runners](https://docs.github.com/en/actions/hosting-your-own-runners/about-self-hosted-runners) support.
* List all files and directories that have changed:
* Between the current pull request branch and the last commit on the target branch.
* Between the current pull request branch and the fork point on the target branch.
* Between the last commit and the current pushed change.
* Between the last remote branch commit and the current HEAD.
* Restrict change detection to a subset of files and directories:
* Report on files that have at least one change.
* Boolean output indicating that certain files have been changed.
* Using [Glob pattern](https://docs.github.com/en/actions/learn-github-actions/workflow-syntax-for-github-actions#filter-pattern-cheat-sheet) matching.
## Usage
@@ -44,9 +42,9 @@ Retrieve all changed files and directories relative to the target branch (`pull_
> NOTE: :warning:
>
> * **IMPORTANT:** For `push` events you need to include `fetch-depth: 0` **OR** `fetch-depth: 2` depending on your use case.
> * When using `persist-credentials: false` with `actions/checkout@v3` you'll need to specify a `token` using the `token` input.
> * For monorepos where pulling all the branch history might not be desired, you can omit `fetch-depth` for `pull_request` events.
> * For files located in a sub-directory ensure that the pattern specified contains `**/` (globstar) to match any preceding directories or explicitly pass the full path relative to the project root. See: [#314](https://github.com/tj-actions/changed-files/issues/314).
> * All multiline inputs should not use double or single qoutes since the value is already a string seperated by a newline character. See [Examples](#examples) for more information.
```yaml
name: CI
@@ -67,16 +65,31 @@ jobs:
- uses: actions/checkout@v3
with:
fetch-depth: 0 # OR "2" -> To retrieve the preceding commit.
# Example 1
- name: Get changed files
id: changed-files
uses: tj-actions/changed-files@v28.0.0
uses: tj-actions/changed-files@v30
- name: List all changed files
run: |
for file in ${{ steps.changed-files.outputs.all_changed_files }}; do
echo "$file was changed"
done
# Example 2
- name: Get changed files in the docs folder
id: changed-files-specific
uses: tj-actions/changed-files@v30
with:
files: |
docs/**
- name: Run step if any file(s) in the docs folder change
if: steps.changed-files-specific.outputs.any_changed == 'true'
run: |
echo "One or more files in the docs folder has changed."
echo "List all the files that have changed: ${{ steps.changed-files-specific.outputs.all_changed_files }}"
```
If you feel generous and want to show some extra appreciation:
@@ -105,51 +118,49 @@ Support this project with a :star:
| Output | type | example | description |
|:----------------------------------:|:--------:|:--------------------------------------------------------------:|:---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------:|
| any\_changed | `string` | `true` OR `false` | Returns `true` when any <br /> of the filenames provided using <br /> the `files` input has changed. If no `files` have been specified,<br> an empty string `''` is returned. <br /> i.e. *using a combination of all added, <br />copied, modified and renamed files (ACMR)* |
| only\_changed | `string` | `true` OR `false` | Returns `true` when only <br /> files provided using <br /> the `files` input has changed. If no `files` have been specified,<br> an empty string `''` is returned. (ACMR) |
| other\_changed\_files | `string` | `'new.txt path/to/file.png ...'` | Select all other changed files <br/> not listed in the files input <br /> i.e. *a combination of all added, <br /> copied and modified files (ACMR)* |
| only\_changed | `string` | `true` OR `false` | Returns `true` when only <br /> files provided using <br /> the `files` input has changed. If no `files` have been specified,<br> an empty string `''` is returned. <br /> i.e. *using a combination of all added, <br />copied, modified and renamed files (ACMR)* |
| other\_changed\_files | `string` | `'new.txt path/to/file.png ...'` | Returns all other changed files <br/> not listed in the files input <br /> i.e. *using a combination of all added, <br />copied, modified and renamed files (ACMR)* |
| any\_modified | `string` | `true` OR `false` | Returns `true` when any <br /> of the filenames provided using <br /> the `files` input has been modified. If no `files` have been specified,<br> an empty string `''` is returned. <br /> i.e. *using a combination of all added, <br />copied, modified, renamed, and deleted files (ACMRD)* |
| only\_modified | `string` | `true` OR `false` | Returns `true` when only <br /> files provided using <br /> the `files` input has been modified. If no `files` have been specified,<br> an empty string `''` is returned.(ACMRD) |
| other\_modified\_files | `string` | `'new.txt path/to/file.png ...'` | Select all other modified files <br/> not listed in the files input <br /> i.e. *a combination of all added, <br /> copied, modified, and deleted files (ACMRD)* |
| other\_modified\_files | `string` | `'new.txt path/to/file.png ...'` | Returns all other modified files <br/> not listed in the files input <br /> i.e. *a combination of all added, <br /> copied, modified, and deleted files (ACMRD)* |
| any\_deleted | `string` | `true` OR `false` | Returns `true` when any <br /> of the filenames provided using <br /> the `files` input has been deleted. If no `files` have been specified,<br> an empty string `''` is returned. (D) |
| only\_deleted | `string` | `true` OR `false` | Returns `true` when only <br /> files provided using <br /> the `files` input has been deleted. If no `files` have been specified,<br> an empty string `''` is returned. (D) |
| other\_deleted\_files | `string` | `'new.txt path/to/file.png ...'` | Select all other deleted files <br/> not listed in the files input <br /> i.e. *a combination of all deleted files (D)* |
| all\_changed\_files | `string` | `'new.txt path/to/file.png ...'` | Select all changed files <br /> i.e. *a combination of all added, <br />copied, modified and renamed files (ACMR)* |
| all\_modified\_files | `string` | `'new.txt path/to/file.png ...'` | Select all changed files <br /> i.e. *a combination of all added, <br />copied, modified, renamed and deleted files (ACMRD)* |
| all\_changed\_and\_modified\_files | `string` | `'new.txt path/to/file.png ...'` | Select all changed <br /> and modified files <br /> i.e. *a combination of (ACMRDTUX)* |
| all\_old\_new\_renamed\_files | `string` | `'old name.txt,new name.txt old name 2.txt,new name 2.txt...'` | Select only files that are Renamed and list their old and new names. <br> NOTE: This requires setting `include_all_old_new_renamed_files` to `true` (R) |
| added\_files | `string` | `'new.txt path/to/file.png ...'` | Select only files that are Added (A) |
| copied\_files | `string` | `'new.txt path/to/file.png ...'` | Select only files that are Copied (C) |
| deleted\_files | `string` | `'new.txt path/to/file.png ...'` | Select only files that are Deleted (D) |
| modified\_files | `string` | `'new.txt path/to/file.png ...'` | Select only files that are Modified (M) |
| renamed\_files | `string` | `'new.txt path/to/file.png ...'` | Select only files that are Renamed (R) |
| type\_changed\_files | `string` | `'new.txt path/to/file.png ...'` | Select only files that have their file type changed (T) |
| unmerged\_files | `string` | `'new.txt path/to/file.png ...'` | Select only files that are Unmerged (U) |
| unknown\_files | `string` | `'new.txt path/to/file.png ...'` | Select only files that are Unknown (X) |
| other\_deleted\_files | `string` | `'new.txt path/to/file.png ...'` | Returns all other deleted files <br/> not listed in the files input <br /> i.e. *a combination of all deleted files (D)* |
| all\_changed\_files | `string` | `'new.txt path/to/file.png ...'` | Returns all changed files <br /> i.e. *a combination of all added, <br />copied, modified and renamed files (ACMR)* |
| all\_modified\_files | `string` | `'new.txt path/to/file.png ...'` | Returns all changed files <br /> i.e. *a combination of all added, <br />copied, modified, renamed and deleted files (ACMRD)* |
| all\_changed\_and\_modified\_files | `string` | `'new.txt path/to/file.png ...'` | Returns all changed <br /> and modified files <br /> i.e. *a combination of (ACMRDTUX)* |
| all\_old\_new\_renamed\_files | `string` | `'old name.txt,new name.txt old name 2.txt,new name 2.txt...'` | Returns only files that are Renamed and list their old and new names. <br> NOTE: This requires setting `include_all_old_new_renamed_files` to `true` (R) |
| added\_files | `string` | `'new.txt path/to/file.png ...'` | Returns only files that are Added (A) |
| copied\_files | `string` | `'new.txt path/to/file.png ...'` | Returns only files that are Copied (C) |
| deleted\_files | `string` | `'new.txt path/to/file.png ...'` | Returns only files that are Deleted (D) |
| modified\_files | `string` | `'new.txt path/to/file.png ...'` | Returns only files that are Modified (M) |
| renamed\_files | `string` | `'new.txt path/to/file.png ...'` | Returns only files that are Renamed (R) |
| type\_changed\_files | `string` | `'new.txt path/to/file.png ...'` | Returns only files that have their file type changed (T) |
| unmerged\_files | `string` | `'new.txt path/to/file.png ...'` | Returns only files that are Unmerged (U) |
| unknown\_files | `string` | `'new.txt path/to/file.png ...'` | Returns only files that are Unknown (X) |
## Inputs
| Input | type | required | default | description |
|:--------------------------------------:|:----------------------:|:--------:|:---------------------:|:-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------:|
| token | `string` | `false` | `${{ github.token }}` | [GITHUB\_TOKEN](https://docs.github.com/en/free-pro-team@latest/actions/reference/authentication-in-a-workflow#using-the-github_token-in-a-workflow) <br /> or a repo scoped <br /> [Personal Access Token](https://docs.github.com/en/free-pro-team@latest/github/authenticating-to-github/creating-a-personal-access-token) |
| separator | `string` | `false` | `' '` | Split character for output strings |
| include\_all\_old\_new\_renamed\_files | `boolean` | `false` | `false` | Include `all_old_new_renamed_files` output. Note this can generate a large output See: [#501](https://github.com/tj-actions/changed-files/issues/501). |
| old\_new\_separator | `string` | `false` | `','` | Split character for old and new filename pairs |
| old\_new\_files\_separator | `string` | `false` | `' '` | Split character for multiple old and new filename pairs |
| files | `string` OR `string[]` | `false` | | Check for changes <br> using only these <br> list of file(s) <br> (Defaults to the <br> entire repo) |
| files | `string` OR `string[]` | `false` | | Check for changes <br> using only these <br> list of file(s) <br> (Defaults to the <br> entire repo) <br /> **NOTE:** Multiline file/directory patterns <br /> should not include qoutes. <br /> |
| files\_separator | `string` | `false` | `'\n'` | Separator used to split the<br>`files` input |
| files\_from\_source\_file | `string` | `false` | | Source file(s) <br> used to populate <br> the `files` input |
| files\_ignore | `string` | `false` | | Ignore changes to these file(s) |
| files\_ignore | `string` | `false` | | Ignore changes to these file(s) <br /> **NOTE:** Multiline file/directory patterns <br /> should not include qoutes. <br /> |
| files\_ignore\_separator | `string` | `false` | `'\n'` | Separator used to split the <br>`files-ignore` input |
| files\_ignore\_from\_source\_file | `string` | `false` | | Source file(s) <br> used to populate <br> the `files_ignore` input |
| sha | `string` | `true` | `${{ github.sha }}` | Specify a different <br> commit SHA <br> used for <br> comparing changes |
| base\_sha | `string` | `false` | | Specify a different <br> base commit SHA <br> used for <br> comparing changes |
| path | `string` | `false` | `'.'` | Relative path under <br> `GITHUB_WORKSPACE` <br> to the repository |
| since\_last\_remote\_commit | `boolean` | `false` | `false` | Use the last commit on the remote <br> branch as the `base_sha` <br> (Defaults to the last commit <br> on the target branch for Pull requests <br> or the previous commit <br> on the current branch <br> for push events). <br /> NOTE: This requires <br /> `fetch-depth: 0` <br /> with `actions/checkout@v3` |
| use\_fork\_point | `boolean` | `false` | `false` | Finds best common ancestor <br /> between two commits <br /> to use in a three-way merge <br /> as the `base_sha` <br /> See: [git merge-base](https://git-scm.com/docs/git-merge-base#Documentation/git-merge-base.txt---fork-point). <br> NOTE: This pulls the entire commit history of the base branch |
| since\_last\_remote\_commit | `boolean` | `false` | `false` | Use the last commit on the remote <br> branch as the `base_sha` <br> (Defaults to the last commit <br> on the target branch for Pull requests <br> or the previous commit <br> on the current branch <br> for push events). <br /> **NOTE:** This requires <br /> `fetch-depth: 0` <br /> with `actions/checkout@v3` |
| quotepath | `boolean` | `false` | `true` | Output filenames completely verbatim by setting this to `false` |
| diff\_relative | `boolean` | `false` | | Exclude changes outside the current directory and show pathnames relative to it. |
| dir\_names | `boolean` | `false` | `false` | Output unique changed directories instead of filenames. <br> NOTE: This returns `.` for <br> changed files located in the root of the project. |
| json | `boolean` | `false` | `false` | Output changed files in JSON format which can be used for matrix jobs. |
| dir\_names | `boolean` | `false` | `false` | Output unique changed directories instead of filenames. <br> **NOTE:** This returns `.` for <br> changed files located in the root of the project. |
| json | `boolean` | `false` | `false` | Output changed files in JSON format which can be used for [matrix jobs](https://github.com/tj-actions/changed-files/blob/main/.github/workflows/manual-matrix-test.yml). |
| since | `string` | `false` | | Get changed files for commits whose timestamp is older than the given time. |
| until | `string` | `false` | | Get changed files for commits whose timestamp is earlier than the given time. |
@@ -165,11 +176,11 @@ Support this project with a :star:
- name: Get changed files using defaults
id: changed-files
uses: tj-actions/changed-files@v28.0.0
uses: tj-actions/changed-files@v30
- name: Get changed files using a comma separator
id: changed-files-comma
uses: tj-actions/changed-files@v28.0.0
uses: tj-actions/changed-files@v30
with:
separator: ","
@@ -191,7 +202,7 @@ Support this project with a :star:
- name: Get specific changed files
id: changed-files-specific
uses: tj-actions/changed-files@v28.0.0
uses: tj-actions/changed-files@v30
with:
files: |
my-file.txt
@@ -232,14 +243,14 @@ Support this project with a :star:
- name: Use a source file or list of file(s) to populate to files input.
id: changed-files-specific-source-file
uses: tj-actions/changed-files@v28.0.0
uses: tj-actions/changed-files@v30
with:
files_from_source_file: |
test/changed-files-list.txt
- name: Use a source file or list of file(s) to populate to files input and optionally specify more files.
id: changed-files-specific-source-file-and-specify-files
uses: tj-actions/changed-files@v28.0.0
uses: tj-actions/changed-files@v30
with:
files_from_source_file: |
test/changed-files-list.txt
@@ -248,15 +259,15 @@ Support this project with a :star:
- name: Use a different commit SHA
id: changed-files-custom-sha
uses: tj-actions/changed-files@v28.0.0
uses: tj-actions/changed-files@v30
with:
sha: ${{ github.event.pull_request.head.sha }}
- name: Use a different base SHA
id: changed-files-custom-base-sha
uses: tj-actions/changed-files@v28.0.0
uses: tj-actions/changed-files@v30
with:
base_sha: "2096ed0"
base_sha: ${{ github.event.pull_request.base.sha }}
- name: Checkout into dir1
uses: actions/checkout@v3
@@ -266,7 +277,7 @@ Support this project with a :star:
- name: Run changed-files with defaults on the dir1
id: changed-files-for-dir1
uses: tj-actions/changed-files@v28.0.0
uses: tj-actions/changed-files@v30
with:
path: dir1
@@ -278,19 +289,13 @@ Support this project with a :star:
- name: Run changed-files using the last commit on the remote branch
id: changed-files-since-last-remote-commit
uses: tj-actions/changed-files@v28.0.0
uses: tj-actions/changed-files@v30
with:
since_last_remote_commit: "true"
- name: Run changed-files using the fork point of a pull request
id: changed-files-fork-point
uses: tj-actions/changed-files@v28.0.0
with:
use_fork_point: "true"
- name: Run changed-files with quotepath disabled
id: changed-files-quotepath
uses: tj-actions/changed-files@v28.0.0
uses: tj-actions/changed-files@v30
with:
quotepath: "false"
@@ -301,7 +306,7 @@ Support this project with a :star:
# Push event based workflows
- name: Get branch name
id: branch-name
uses: tj-actions/branch-names@v5
uses: tj-actions/branch-names@v6
- uses: nrwl/last-successful-commit-action@v1
id: last_successful_commit_push
@@ -312,7 +317,7 @@ Support this project with a :star:
- name: Run changed-files with the commit of the last successful test workflow run
id: changed-files-base-sha-push
uses: tj-actions/changed-files@v28.0.0
uses: tj-actions/changed-files@v30
with:
base_sha: ${{ steps.last_successful_commit_push.outputs.commit_hash }}
@@ -333,32 +338,32 @@ Support this project with a :star:
- name: Run changed-files with the commit of the last successful test workflow run on main
if: github.event_name == 'pull_request'
id: changed-files-base-sha-pull-request
uses: tj-actions/changed-files@v28.0.0
uses: tj-actions/changed-files@v30
with:
base_sha: ${{ steps.last_successful_commit_pull_request.outputs.commit_hash }}
- name: Run changed-files with dir_names
id: changed-files-dir-names
uses: tj-actions/changed-files@v28.0.0
uses: tj-actions/changed-files@v30
with:
dir_names: "true"
# All outputs are JSON formatted arrays and can be used in other actions and matrix compatible jobs.
- name: Run changed-files with json output
id: changed-files-json
uses: tj-actions/changed-files@v28.0.0
with:
uses: tj-actions/changed-files@v30
wi
json: "true"
- name: Run changed-files since 2022-08-19
id: changed-files-since
uses: tj-actions/changed-files@v28.0.0
uses: tj-actions/changed-files@v30
with:
since: "2022-08-19"
- name: Run changed-files until 2022-08-20
id: changed-files-until
uses: tj-actions/changed-files@v28.0.0
uses: tj-actions/changed-files@v30
with:
until: "2022-08-20"
```

View File

@@ -3,10 +3,6 @@ description: Get all Added, Copied, Modified, Deleted, Renamed, Type changed, Un
author: tj-actions
inputs:
token:
description: "Github token"
required: false
default: ${{ github.token }}
separator:
description: "Split character for output strings"
required: false
@@ -61,17 +57,15 @@ inputs:
since:
description: "Get changed files for commits whose timestamp is older than the given time"
required: false
default: ""
until:
description: "Get changed files for commits whose timestamp is earlier than the given time"
required: false
default: ""
path:
description: "Specify a relative path under $GITHUB_WORKSPACE to locate the repository"
required: false
default: "."
use_fork_point:
description: "Finds best common ancestor between two commits to use in a three-way merge as the base_sha"
default: "false"
required: false
quotepath:
description: "Output filenames completely verbatim by setting this to false"
default: "true"
@@ -157,32 +151,32 @@ runs:
using: "composite"
steps:
- run: |
# "Set base sha..."
if [[ -n "${{ inputs.since }}" ]]; then
BASE_SHA=$(git log --format="%H" --date=local --since="${{ inputs.since }}" --reverse | head -n 1)
echo "::set-output name=base_sha::$BASE_SHA"
elif [[ -n "${{ inputs.base_sha }}" ]]; then
echo "::set-output name=base_sha::${{ inputs.base_sha }}"
elif [[ "${{ inputs.since_last_remote_commit }}" == "true" && "${{ github.event.forced }}" == "true" && "${{ github.event.before }}" != "0000000000000000000000000000000000000000" ]]; then
LAST_REMOTE_COMMIT=$(git rev-parse $(git branch -r --sort=-committerdate | head -1))
if [[ "${{ inputs.sha }}" != "$LAST_REMOTE_COMMIT" ]]; then
echo "::set-output name=base_sha::$LAST_REMOTE_COMMIT"
fi
elif [[ "${{ inputs.since_last_remote_commit }}" == "true" && "${{ github.event.forced }}" != "true" && "${{ github.event.before }}" != "0000000000000000000000000000000000000000" ]]; then
echo "::set-output name=base_sha::${{ github.event.before }}"
fi
# "Calculate the base sha..."
bash $GITHUB_ACTION_PATH/get-base-sha.sh
id: base-sha
shell: bash
env:
GITHUB_WORKSPACE: ${{ github.workspace }}
GITHUB_EVENT_BEFORE: ${{ github.event.before }}
# INPUT_<VARIABLE_NAME> is not available in Composite run steps
# https://docs.github.com/en/actions/creating-actions/metadata-syntax-for-github-actions#example-specifying-inputs
INPUT_SINCE: ${{ inputs.since }}
INPUT_BASE_SHA: ${{ inputs.base_sha }}
INPUT_SHA: ${{ inputs.sha }}
INPUT_PATH: ${{ inputs.path }}
INPUT_SINCE_LAST_REMOTE_COMMIT: ${{ inputs.since_last_remote_commit }}
- run: |
# "Set the sha..."
if [[ -n "${{ inputs.until }}" ]]; then
SHA=$(git log -1 --format="%H" --date=local --until="${{ inputs.until }}")
echo "::set-output name=sha::$SHA"
else
echo "::set-output name=sha::${{ inputs.sha }}"
fi
# "Calculate the sha..."
bash $GITHUB_ACTION_PATH/get-sha.sh
id: sha
shell: bash
env:
GITHUB_WORKSPACE: ${{ github.workspace }}
# INPUT_<VARIABLE_NAME> is not available in Composite run steps
# https://docs.github.com/en/actions/creating-actions/metadata-syntax-for-github-actions#example-specifying-inputs
INPUT_UNTIL: ${{ inputs.until }}
INPUT_SHA: ${{ inputs.sha }}
INPUT_PATH: ${{ inputs.path }}
- run: |
# "Calculating the previous and current SHA..."
bash $GITHUB_ACTION_PATH/diff-sha.sh
@@ -193,40 +187,38 @@ runs:
GITHUB_REPOSITORY: ${{ github.repository }}
GITHUB_BASE_REF: ${{ github.base_ref }}
GITHUB_HEAD_REF: ${{ github.head_ref }}
GITHUB_ACTION_PATH: ${{ github.action_path }}
GITHUB_WORKSPACE: ${{ github.workspace }}
GITHUB_PULL_REQUEST_BASE_SHA: ${{ github.event.pull_request.base.sha }}
GITHUB_EVENT_BEFORE: ${{ github.event.before }}
# INPUT_<VARIABLE_NAME> is not available in Composite run steps
# https://github.community/t/input-variable-name-is-not-available-in-composite-run-steps/127611
# https://docs.github.com/en/actions/creating-actions/metadata-syntax-for-github-actions#example-specifying-inputs
INPUT_SHA: ${{ steps.sha.outputs.sha }}
INPUT_BASE_SHA: ${{ steps.base-sha.outputs.base_sha }}
INPUT_TOKEN: ${{ inputs.token }}
INPUT_PATH: ${{ inputs.path }}
INPUT_USE_FORK_POINT: ${{ inputs.use_fork_point }}
- name: Glob match
uses: tj-actions/glob@v12
uses: tj-actions/glob@v13
id: glob
with:
files: ${{ inputs.files }}
files-separator: ${{ inputs.files_separator }}
escape-paths: true
excluded-files: ${{ inputs.files_ignore }}
excluded-files-separator: ${{ inputs.files_ignore_separator }}
files-from-source-file: ${{ inputs.files_from_source_file }}
excluded-files-from-source-file: ${{ inputs.files_ignore_from_source_file}}
escape-paths: true
working-directory: ${{ inputs.path }}
base-sha: ${{ steps.changed-files-diff-sha.outputs.previous_sha }}
sha: ${{ steps.changed-files-diff-sha.outputs.current_sha }}
include-deleted-files: true
separator: "|"
- run: |
bash $GITHUB_ACTION_PATH/entrypoint.sh
bash $GITHUB_ACTION_PATH/get-changed-paths.sh
id: changed-files
shell: bash
env:
GITHUB_ACTION_PATH: ${{ github.action_path }}
GITHUB_WORKSPACE: ${{ github.workspace }}
# INPUT_<VARIABLE_NAME> is not available in Composite run steps
# https://github.community/t/input-variable-name-is-not-available-in-composite-run-steps/127611
# https://docs.github.com/en/actions/creating-actions/metadata-syntax-for-github-actions#example-specifying-inputs
INPUT_FILES_PATTERN_FILE: ${{ steps.glob.outputs.paths-output-file }}
INPUT_SEPARATOR: ${{ inputs.separator }}
INPUT_PATH: ${{ inputs.path }}
@@ -241,6 +233,7 @@ runs:
INPUT_DIFF_RELATIVE: ${{ inputs.diff_relative }}
INPUT_DIR_NAMES: ${{ inputs.dir_names }}
INPUT_JSON: ${{ inputs.json }}
INPUT_HAS_CUSTOM_PATTERNS: ${{ steps.glob.outputs.has-custom-patterns }}
branding:
icon: file-text

View File

@@ -23,7 +23,7 @@ function __version() {
echo "$@" | awk -F. '{ printf("%d%03d%03d%03d\n", $1,$2,$3,$4); }';
}
GIT_VERSION=$(git --version | awk '{print $3}'); exit_status=$?
GIT_VERSION=$(git --version | awk '{print $3}') && exit_status=$? || exit_status=$?
if [[ $exit_status -ne 0 ]]; then
echo "::error::git not installed"
@@ -40,12 +40,13 @@ fi
echo "::debug::Getting HEAD SHA..."
if [[ -z $INPUT_SHA ]]; then
CURRENT_SHA=$(git rev-list -n 1 "HEAD" 2>&1); exit_status=$?
CURRENT_SHA=$(git rev-list -n 1 "HEAD" 2>&1) && exit_status=$? || exit_status=$?
else
CURRENT_SHA=$INPUT_SHA; exit_status=$?
fi
git rev-parse --quiet --verify "$CURRENT_SHA^{commit}" 1>/dev/null 2>&1; exit_status=$?
echo "::debug::Verifying the current commit SHA: $CURRENT_SHA"
git rev-parse --quiet --verify "$CURRENT_SHA^{commit}" 1>/dev/null 2>&1 && exit_status=$? || exit_status=$?
if [[ $exit_status -ne 0 ]]; then
echo "::error::Unable to locate the current sha: $CURRENT_SHA"
@@ -56,29 +57,37 @@ else
fi
if [[ -z $GITHUB_BASE_REF ]]; then
TARGET_BRANCH=${GITHUB_REF/refs\/heads\//}
CURRENT_BRANCH=$TARGET_BRANCH
echo "::debug::GITHUB_BASE_REF unset using $TARGET_BRANCH..."
echo "Running on a push event..."
TARGET_BRANCH=${GITHUB_REF/refs\/heads\//} && exit_status=$? || exit_status=$?
CURRENT_BRANCH=$TARGET_BRANCH && exit_status=$? || exit_status=$?
if [[ -z $INPUT_BASE_SHA ]]; then
if [[ $(git rev-list --count "HEAD") -gt 1 ]]; then
PREVIOUS_SHA=$(git rev-parse "@~" 2>&1); exit_status=$?
echo "::debug::Previous SHA: $PREVIOUS_SHA"
else
PREVIOUS_SHA=$CURRENT_SHA; exit_status=$?
INITIAL_COMMIT="true"
echo "::debug::Initial commit detected"
echo "::debug::Previous SHA: $PREVIOUS_SHA"
PREVIOUS_SHA=$GITHUB_EVENT_BEFORE
if [[ -z "$PREVIOUS_SHA" || "$PREVIOUS_SHA" == "0000000000000000000000000000000000000000" ]]; then
echo "::debug::First commit detected"
PREVIOUS_SHA=$(git rev-parse "$(git branch -r --sort=-committerdate | head -1 | xargs)")
fi
if [[ "$PREVIOUS_SHA" == "$CURRENT_SHA" ]]; then
PREVIOUS_SHA=$(git rev-parse "$CURRENT_SHA^1")
if [[ "$PREVIOUS_SHA" == "$CURRENT_SHA" ]]; then
INITIAL_COMMIT="true"
echo "::debug::Initial commit detected"
fi
fi
else
PREVIOUS_SHA=$INPUT_BASE_SHA; exit_status=$?
TARGET_BRANCH=$(git name-rev --name-only "$PREVIOUS_SHA" 2>&1); exit_status=$?
echo "::debug::Previous SHA: $PREVIOUS_SHA"
echo "::debug::Target branch: $TARGET_BRANCH"
PREVIOUS_SHA=$INPUT_BASE_SHA
TARGET_BRANCH=$(git name-rev --name-only "$PREVIOUS_SHA" 2>&1) && exit_status=$? || exit_status=$?
CURRENT_BRANCH=$TARGET_BRANCH
fi
git rev-parse --quiet --verify "$PREVIOUS_SHA^{commit}" 1>/dev/null 2>&1; exit_status=$?
echo "::debug::Target branch $TARGET_BRANCH..."
echo "::debug::Current branch $CURRENT_BRANCH..."
echo "::debug::Verifying the previous commit SHA: $PREVIOUS_SHA"
git rev-parse --quiet --verify "$PREVIOUS_SHA^{commit}" 1>/dev/null 2>&1 && exit_status=$? || exit_status=$?
if [[ $exit_status -ne 0 ]]; then
echo "::error::Unable to locate the previous sha: $PREVIOUS_SHA"
@@ -86,32 +95,24 @@ if [[ -z $GITHUB_BASE_REF ]]; then
exit 1
fi
else
echo "Running on a pull request event..."
TARGET_BRANCH=$GITHUB_BASE_REF
CURRENT_BRANCH=$GITHUB_HEAD_REF
echo "::debug::GITHUB_BASE_REF: $TARGET_BRANCH..."
if [[ -z $INPUT_BASE_SHA ]]; then
if [[ "$INPUT_USE_FORK_POINT" == "true" ]]; then
echo "::debug::Getting fork point..."
git fetch --no-tags -u --progress origin "${TARGET_BRANCH}":"${TARGET_BRANCH}"; exit_status=$?
PREVIOUS_SHA=$(git merge-base --fork-point "${TARGET_BRANCH}" "$(git name-rev --name-only "$CURRENT_SHA")"); exit_status=$?
echo "::debug::Previous SHA: $PREVIOUS_SHA"
else
git fetch --no-tags -u --progress origin --depth=1 "${TARGET_BRANCH}":"${TARGET_BRANCH}"; exit_status=$?
PREVIOUS_SHA=$(git rev-list -n 1 "${TARGET_BRANCH}" 2>&1); exit_status=$?
echo "::debug::Previous SHA: $PREVIOUS_SHA"
fi
PREVIOUS_SHA=$GITHUB_PULL_REQUEST_BASE_SHA && exit_status=$? || exit_status=$?
echo "::debug::Previous SHA: $PREVIOUS_SHA"
else
git fetch --no-tags -u --progress origin --depth=1 "$(git rev-parse --verify "$INPUT_BASE_SHA")"; exit_status=$?
PREVIOUS_SHA=$INPUT_BASE_SHA
TARGET_BRANCH=$(git name-rev --name-only "$PREVIOUS_SHA" 2>&1); exit_status=$?
TARGET_BRANCH=$(git name-rev --name-only "$PREVIOUS_SHA" 2>&1) && exit_status=$? || exit_status=$?
echo "::debug::Previous SHA: $PREVIOUS_SHA"
echo "::debug::Target branch: $TARGET_BRANCH"
fi
echo "::debug::Verifying commit SHA..."
git rev-parse --quiet --verify "$PREVIOUS_SHA^{commit}" 1>/dev/null 2>&1; exit_status=$?
echo "::debug::Verifying the previous commit SHA: $PREVIOUS_SHA"
git rev-parse --quiet --verify "$PREVIOUS_SHA^{commit}" 1>/dev/null 2>&1 && exit_status=$? || exit_status=$?
if [[ $exit_status -ne 0 ]]; then
echo "::error::Unable to locate the previous sha: $PREVIOUS_SHA"
@@ -122,6 +123,7 @@ fi
if [[ -n "$PREVIOUS_SHA" && -n "$CURRENT_SHA" && "$PREVIOUS_SHA" == "$CURRENT_SHA" && "$INITIAL_COMMIT" == "false" ]]; then
echo "::error::Similar commit hashes detected: previous sha: $PREVIOUS_SHA is equivalent to the current sha: $CURRENT_SHA"
echo "::error::You seem to be missing 'fetch-depth: 0' or 'fetch-depth: 2'. See https://github.com/tj-actions/changed-files#usage"
exit 1
fi

35
get-base-sha.sh Normal file
View File

@@ -0,0 +1,35 @@
#!/usr/bin/env bash
set -eu
if [[ -n $INPUT_PATH ]]; then
REPO_DIR="$GITHUB_WORKSPACE/$INPUT_PATH"
echo "Resolving repository path: $REPO_DIR"
if [[ ! -d "$REPO_DIR" ]]; then
echo "::error::Invalid repository path: $REPO_DIR"
exit 1
fi
cd "$REPO_DIR"
fi
if [[ -n "$INPUT_SINCE" ]]; then
BASE_SHA=$(git log --format="%H" --date=local --since="$INPUT_SINCE" --reverse | head -n 1)
if [[ -z "$BASE_SHA" ]]; then
echo "::warning::The BASE_SHA for date '$INPUT_SINCE' couldn't be determined."
fi
echo "::set-output name=base_sha::$BASE_SHA"
elif [[ -n "$INPUT_BASE_SHA" ]]; then
echo "::set-output name=base_sha::$INPUT_BASE_SHA"
elif [[ "$INPUT_SINCE_LAST_REMOTE_COMMIT" == "true" ]]; then
LAST_REMOTE_COMMIT="$GITHUB_EVENT_BEFORE"
if [[ -z "$LAST_REMOTE_COMMIT" || "$LAST_REMOTE_COMMIT" == "0000000000000000000000000000000000000000" ]]; then
echo "::debug::First commit detected"
LAST_REMOTE_COMMIT=$(git rev-parse "$(git branch -r --sort=-committerdate | head -1 | xargs)")
fi
if [[ "$INPUT_SHA" == "$LAST_REMOTE_COMMIT" ]]; then
LAST_REMOTE_COMMIT=$(git rev-parse "$INPUT_SHA^1")
fi
echo "::set-output name=base_sha::$LAST_REMOTE_COMMIT"
fi

View File

@@ -81,7 +81,7 @@ echo "Retrieving changes between $INPUT_PREVIOUS_SHA ($INPUT_TARGET_BRANCH) →
echo "Getting diff..."
if [[ -z "$INPUT_FILES_PATTERN_FILE" ]]; then
if [[ "$INPUT_HAS_CUSTOM_PATTERNS" == "false" ]]; then
if [[ "$INPUT_JSON" == "false" ]]; then
ADDED=$(get_diff "$INPUT_PREVIOUS_SHA" "$INPUT_CURRENT_SHA" A | awk -v d="$INPUT_SEPARATOR" '{s=(NR==1?s:s d)$0}END{print s}')
COPIED=$(get_diff "$INPUT_PREVIOUS_SHA" "$INPUT_CURRENT_SHA" C | awk -v d="$INPUT_SEPARATOR" '{s=(NR==1?s:s d)$0}END{print s}')

24
get-sha.sh Normal file
View File

@@ -0,0 +1,24 @@
#!/usr/bin/env bash
set -eu
if [[ -n $INPUT_PATH ]]; then
REPO_DIR="$GITHUB_WORKSPACE/$INPUT_PATH"
echo "Resolving repository path: $REPO_DIR"
if [[ ! -d "$REPO_DIR" ]]; then
echo "::error::Invalid repository path: $REPO_DIR"
exit 1
fi
cd "$REPO_DIR"
fi
if [[ -n "$INPUT_UNTIL" ]]; then
SHA=$(git log -1 --format="%H" --date=local --until="$INPUT_UNTIL")
if [[ -z "$SHA" ]]; then
echo "::warning::The SHA for date '$INPUT_UNTIL' couldn't be determined, falling back to the current sha."
fi
echo "::set-output name=sha::$SHA"
else
echo "::set-output name=sha::$INPUT_SHA"
fi

View File

@@ -1 +1 @@
This is a test file.
This is test file 1.

View File

@@ -1 +1 @@
This is a test file.
This is test file 2.